(******************************************************************)
(* ZipSFX                                                         *)
(*                                                                *)
(* Copyright 1997, Carl Bunton                							 *)
(* Home of ZipTV compression components for Delphi                *)
(* Email: Twojags@cris.com                                        *)
(* Web-page: http://www.concentric.net/~twojags                   *)
(*                                                                *)
(* Redistribution of this code is authorized so long as these     *)
(* copyright headers are not removed and the code is not altered  *)
(* in any way.                                                    *)
(*                                                                *)
(* This program was written in Delphi 2 because version 2         *)
(* compiles a much smaller executable using the windows api.  It  *)
(* should be fully compatible with Delphi 3, but will produce a   *)
(* noticable increase of size in the final compiled program.      *)
(*                                                                *)
(* CAUTION: if compiling in Delphi 3, please see note below about *)
(* the storage of the compiled file in a string table.  This      *)
(* program will not work unless the value in the string table     *)
(* is "equal to" the compiled file size.  This value is currently *)
(* set to the size of the compiled file that is produced using    *)
(* Delphi 2, therefore Delphi 3 will not work until this value    *)
(* is changed to the size of the compiled file Delphi 3 produces. *)
(*                                                                *)
(******************************************************************)


{
	NOTES:

  -The current display screens are contained in the SFX.RES file. To
   edit them requires a resource editor.  Borland Int'l distributes
   a resource editor that is not very expensive.  Its called 'Resource
   Workshop'.

  -The size of the exe module is defined in the SFX.RES file as a
   string table.  Since there are four SFX programs in this series,
   there are four sizes listed in the string table.  The values of
   these four string table constants are listed in SFXgbls.PAS file
   as follows:

      (* String Table constants *)
      BHSFX 		  = 1;
      ZIPSFX		  = 2;  <- SFX for ZIP files is 2nd in the string table
      ARJSFX		  = 3;
      LHASFX		  = 4;

  IMPORTANT - The size of the compiled executable (without appended
  archive ) and the value in the string table must match or equal.
  This is how this program determines the starting position of the
  first compressed file.

	If there are any questions regarding this code, please don't hesitate
  to contact me.

	Enjoy...

}

PROGRAM Sfx;




USES
	Dialog,
	SFXgbls,
  SFXmisc,
	Messages,
  Windows;




{$R SFX.RES}




BEGIN
										(* Open the archive *)

  InFile := CreateFile( PChar( ParamStr( 0 ) ),
  							GENERIC_READ,
                       FILE_SHARE_READ,
                       NIL,
                       OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL,
                       0 );

                             (* If error, notify and abort *)

  IF InFile = INVALID_HANDLE_VALUE THEN
  BEGIN
     MessageBox( 0, PChar( ParamStr( 0 ) ), 'Couldn''t open...', mb_OK );
     EXIT;
  END;


  New( CRC32Table );
  Make_CRC32Table;

	TRY
                             (* Get the beginning offset OF the archive *)

     StartOfFile := GetArchiveOffset;

                             (* If no appended archive, notify and abort *)

     IF StartOfFile = 0 THEN
     BEGIN
        MessageBox( 0, 'Couldn''t find attached archive.'#13 + 'Syntax: COPY /b ZipSfx.exe + MyArc.zip MyArc.exe', 'BlakHole Zip SFX', mb_OK );
        EXIT;

     END;

                             (* Display the dialog *)

     DialogBox( hInstance, 'MainDialog', 0, @MainDialogProc );


  FINALLY
                             (* Close the archive *)

     IF NOT CloseHandle( InFile ) THEN
        MessageBox( 0, 'Error closing file', 'Error', mb_OK );

     Dispose( CRC32Table );

  END;
END.




